<?php

namespace FiloBlu\DynamicCustomOptions\Controller\Adminhtml\DynamicCustomOptions;

class Delete extends \FiloBlu\DynamicCustomOptions\Controller\Adminhtml\DynamicCustomOptions\DynamicCustomOptions
{
    /**
     * Delete dynamicCustomOptions action
     *
     * @return void
     */
    public function execute()
    {
        $id = $this->getRequest()->getParam('id');
        if ($id) {
            try {
                /** @var \FiloBlu\DynamicCustomOptions\Model\DynamicCustomOptions $model */
                $model = $this->dynamicCustomOptionsFactory->create();
                $model->load($id);
                $model->delete();
                $this->messageManager->addSuccessMessage(__('You deleted the dynamic custom options.'));
                $this->_redirect('filobludynamiccustomoptionsadmin/*/');
                return;
            } catch (\Magento\Framework\Exception\LocalizedException $e) {
                $this->messageManager->addErrorMessage($e->getMessage());
            } catch (\Exception $e) {
                $this->messageManager->addErrorMessage(
                    __('We can\'t delete the dynamic custom options right now. Please review the log and try again.')
                );
                $this->logger->critical($e);
                $this->_redirect('filobludynamiccustomoptionsadmin/*/edit', ['id' => $this->getRequest()->getParam('id')]);
                return;
            }
        }
        $this->messageManager->addErrorMessage(__('We can\'t find a dynamic custom options to delete.'));
        $this->_redirect('filobludynamiccustomoptionsadmin/*/');
    }
}