<?php

namespace FiloBlu\DynamicCustomOptions\Controller\Adminhtml\DynamicCustomOptions;

class Edit extends \FiloBlu\DynamicCustomOptions\Controller\Adminhtml\DynamicCustomOptions\DynamicCustomOptions
{
    /**
     * Dynamic Custom Options edit action
     *
     * @return void
     */
    public function execute()
    {
        $id = $this->getRequest()->getParam('id');
        /** @var \FiloBlu\DynamicCustomOptions\Model\DynamicCustomOptions $model */
        $model = $this->dynamicCustomOptionsFactory->create();

        if ($id) {
            $model->load($id);
            
            if (!$model->getDynamiccustomoptionsId()) {
                $this->messageManager->addErrorMessage(__('This dynamic custom options no longer exists.'));
                $this->_redirect('filobludynamiccustomoptionsadmin/*');
                return;
            }
        }

        // set entered data if was error when we do save
        $data = $this->_session->getPageData(true);
        if (!empty($data)) {
            $model->addData($data);
        }

        $model->getConditions()->setJsFormObject('dynamiccustomoptions_conditions_fieldset');

        $this->coreRegistry->register('current_dynamiccustomoptions', $model);

        $this->_initAction();
        $this->_view->getLayout()
            ->getBlock('dynamiccustomoptions_edit')
            ->setData('action', $this->getUrl('filobludynamiccustomoptionsadmin/*/save'));

        $this->_addBreadcrumb($id ? __('Edit Dynamic Custom Options') : __('New Dynamic Custom Options'), $id ? __('Edit Dynamic Custom Options') : __('New Dynamic Custom Options'));

        $this->_view->getPage()->getConfig()->getTitle()->prepend(
            $model->getDynamiccustomoptionsId() ? $model->getName() : __('New Dynamic Custom Options')
        );
        $this->_view->renderLayout();
    }
}